--코드 5-14 테스트용 테이블 생성
CREATE TABLE TB_SUBWAY_STATN_TMP --지하철역임시
(
  SUBWAY_STATN_NO CHAR(6) NOT NULL --지하철역번호
, LN_NM VARCHAR2(50) NOT NULL --노선명
, STATN_NM VARCHAR2(50) NOT NULL --역명
--기본키 제약조건 설정
, CONSTRAINT PK_TB_SUBWAY_STATN_TMP PRIMARY KEY (SUBWAY_STATN_NO)
);

--코드 5-15 신규 데이터 입력
INSERT INTO TB_SUBWAY_STATN_TMP T
(
  T.SUBWAY_STATN_NO
, T.LN_NM
, T.STATN_NM
)
VALUES
(
  '000032'
, '2호선'
, '강남'
)
;
COMMIT; --DB에 최종적으로 적용(커밋)

--코드 5-16 입력한 데이터 조회
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN_TMP A
 WHERE A.STATN_NM = '강남'
;

--코드 5-17 데이터 수정
UPDATE TB_SUBWAY_STATN_TMP A
   SET A.LN_NM = '녹색선'
     , A.STATN_NM = '강남스타일'
 WHERE A.SUBWAY_STATN_NO = '000032' --역명이 '강남'인 행
;

COMMIT; --DB에 최종적으로 적용(커밋)

--코드 5-18 수정한 데이터 조회
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN_TMP A
 WHERE A.SUBWAY_STATN_NO = '000032'
;

--코드 5-19 데이터 삭제
DELETE
  FROM TB_SUBWAY_STATN_TMP A
 WHERE A.SUBWAY_STATN_NO = '000032'
;

COMMIT; --DB에 최종적으로 적용(커밋)


--코드 5-20 삭제한 데이터 조회
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN_TMP A
 WHERE A.SUBWAY_STATN_NO = '000032'
;

--코드 5-21 SELECT문
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , A.INDUTY_CL_SE_CD
     , NVL(A.UPPER_INDUTY_CL_CD, '(Null)') AS UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL A
 WHERE INDUTY_CL_SE_CD = 'ICS001' --대
;

--코드 5-22 DISTINCT - 1개 칼럼
SELECT DISTINCT A.INDUTY_CL_SE_CD
  FROM TB_INDUTY_CL A
;

--코드 5-23 DISTINCT - 2개 칼럼
SELECT DISTINCT A.POPLTN_SE_CD, A.AGRDE_SE_CD
  FROM TB_POPLTN A
;

--코드 5-24 SELECT *
SELECT *
  FROM TB_INDUTY_CL_SE A
;

--코드 5-25 앨리어스의 사용
SELECT A.INDUTY_CL_CD AS 업종분류코드
     , A.INDUTY_CL_NM AS 업종분류명
     , A.INDUTY_CL_SE_CD AS 업종분류구분코드
     , NVL(A.UPPER_INDUTY_CL_CD, '(Null)') AS 상위업종분류코드
  FROM TB_INDUTY_CL A
 WHERE INDUTY_CL_SE_CD = 'ICS001' --대
;

--코드 5-26 합성 연산자의 사용
SELECT SUBWAY_STATN_NO || '-' || STATN_NM ||'('||LN_NM ||')' AS "지하철역번호-역명(노선명)"
  FROM TB_SUBWAY_STATN
 WHERE LN_NM = '9호선'
;

--코드 5-27 DUAL 테이블
SELECT ( (1+1)*3 ) / 6 AS "연산결과 값"
  FROM DUAL
;