--코드 6-29 계층형 SQL문
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , B.INDUTY_CL_SE_CD
     , B.INDUTY_CL_SE_NM
     , LEVEL LVL
     , LPAD(' ', 4*(LEVEL-1))|| A.INDUTY_CL_CD || '(' || A.INDUTY_CL_NM || ')' AS "업종분류코드(명)"
     , CONNECT_BY_ISLEAF AS CBI
  FROM TB_INDUTY_CL A
     , TB_INDUTY_CL_SE B
 WHERE A.INDUTY_CL_SE_CD = B.INDUTY_CL_SE_CD
 START WITH A.UPPER_INDUTY_CL_CD IS null
 CONNECT BY PRIOR A.INDUTY_CL_CD = A.UPPER_INDUTY_CL_CD
 ORDER SIBLINGS BY A.INDUTY_CL_CD
;

--코드 6-30 계층형 SQL문 - START WITH 조건
SELECT B.INDUTY_CL_CD
     , B.INDUTY_CL_NM
     , LEVEL LVL
     , LPAD(' ', 4*(LEVEL-1))|| B.INDUTY_CL_CD || '(' || B.INDUTY_CL_NM || ')' AS "업종분류코드(명)"
     , CONNECT_BY_ISLEAF AS CBI
     , INDUTY_CL_SE_CD
  FROM TB_INDUTY_CL B
 START WITH B.INDUTY_CL_CD = 'Q12' --커피점/카페
CONNECT BY PRIOR B.INDUTY_CL_CD = B.UPPER_INDUTY_CL_CD
ORDER SIBLINGS BY B.INDUTY_CL_CD
;

--코드 6-31 계층형 SQL문 - CONNECT_BY_ROOT 및 SYS_CONNECT_BY_PATH의 사용
SELECT B.INDUTY_CL_CD
     , B.INDUTY_CL_NM
     , LEVEL LVL
     , CONNECT_BY_ISLEAF AS CBI
     , CONNECT_BY_ROOT INDUTY_CL_CD AS "최상위업종분류코드"
     , SYS_CONNECT_BY_PATH(INDUTY_CL_CD || '(' || INDUTY_CL_NM || ')', '->') AS "업종분류코드경로"
  FROM TB_INDUTY_CL B
 START WITH B.INDUTY_CL_CD = 'Q12' --커피점/카페
CONNECT BY PRIOR B.INDUTY_CL_CD = B.UPPER_INDUTY_CL_CD
ORDER SIBLINGS BY B.INDUTY_CL_CD
;

--코드 6-32 계층형 SQL문 - SELF JOIN의 활용
SELECT A.INDUTY_CL_CD
     , NVL(A.INDUTY_CL_NM, '(Null)') AS INDUTY_CL_NM
     , NVL(A.UPPER_INDUTY_CL_CD, '(Null)') AS "상위업종분류코드"
     , NVL(B.UPPER_INDUTY_CL_CD, '(Null)') AS "차상위업종분류코드"
  FROM TB_INDUTY_CL A
     , TB_INDUTY_CL B
 WHERE A.UPPER_INDUTY_CL_CD = B.INDUTY_CL_CD
   AND A.INDUTY_CL_CD LIKE 'Q12%' --커피점/카페
ORDER BY A.INDUTY_CL_CD
;